import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import clearUndefinedProperties from '../utils/clearUndefinedProperties';
import useApi from './useApi';
export default (() => {
  const [, prepareApi] = useApi();

  function handleShare(_x) {
    return _handleShare.apply(this, arguments);
  }

  function _handleShare() {
    _handleShare = _asyncToGenerator(function* (options) {
      const {
        href,
        display,
        hashtag,
        redirectUri,
        quote,
        mobileIframe
      } = options,
            rest = _objectWithoutProperties(options, ["href", "display", "hashtag", "redirectUri", "quote", "mobileIframe"]);

      const api = yield prepareApi();
      return api.ui(clearUndefinedProperties(_objectSpread({
        method: 'share',
        href,
        display,
        app_id: api.getAppId(),
        hashtag,
        redirect_uri: redirectUri,
        quote,
        mobile_iframe: mobileIframe
      }, rest)));
    });
    return _handleShare.apply(this, arguments);
  }

  return handleShare;
});
//# sourceMappingURL=useShare.js.map